<template lang="html">
  <div class="tags-editor">

    <loadermini class="pull-right"
      :listenFor="`DELETE:Tag:TagEditor`"
      @loadingstart="disableRemoveBtn = true"
      @loadingend="disableRemoveBtn = false"
      leftText="Aguarde..." />

    <loadermini class="pull-right"
      :listenFor="`POST:Tag:TagEditor`"
      @loadingstart="disableAdd = true"
      @loadingend="disableAdd = false"
      leftText="Aguarde..." />

    <div class="added-tags-list">
      <span class="tag-pill" v-for="(item, index) in added_tags">{{returnValue(item, 'text')}} <button class="btn-remove" :disabled="disableRemoveBtn" @click="removeTag(index, $event)"><ficon name="close"/></button></span>
    </div>

    <multiselect
      :options="temas"
      :close-on-select="true"
      :clear-on-select="true"
      :multiple="true"
      :hideSelected="true"
      :max="maxItems"
      :optionsLimit="5"
      :taggable="true"
      :resetAfter="true"
      @tag="addTag"
      @search-change="findTag"
      @input="updateAddedTags"
      tagPlaceholder="Pressione enter para criar um novo tema"
      selectLabel=""
      selectedLabel="Selecionado"
      :placeholder="'Selecione até '+maxItems+' temas'"
      :disabled="maxItems == 0 || disableAdd"
      label="text"
      id="temas-solucao-editor"
      class="form-control">
      <span slot="noResult">Nenhum tema encontrado.</span>
      <span slot="maxElements">Máximo de 5 temas selecionados. Para adicionar outro, primeiro remova um existente</span>
    </multiselect>

  </div>
</template>

<script>
  import Multiselect from 'vue-multiselect'
  import ficon from './ficons-component.vue'
  import loadermini from './loader-mini-component.vue'
  import { findTags, saveTag, removeTag } from '../api/tags.service'

  export default {
    name: "TagsEditor",
    components: { Multiselect, ficon, loadermini },
    props: {
      addedTags: {
        required: true
      },
      max: {
        type: Number
      },
      solutionId: {
        required: true
      }
    },
    data() {
      return {
        temas: [],
        added_tags: [],
        disableRemoveBtn: false,
        disableAdd: false
      }
    },
    watch: {
      addedTags(value) {
        if (value) {
          this.added_tags = value;
        }
      }
    },
    computed: {
      maxItems() {
        if (this.addedTags) {
          return this.max - this.added_tags.length;
        }
      }
    },
    methods: {
      addTag(tag) {
        saveTag(this.solutionId, { tag: tag }, "TagEditor")
          .then(
            success => {
              this.added_tags.push(success.data);
              this.temas = [];
            }
          )
      },
      removeTag(index, event) {
        event.preventDefault();
        removeTag(this.solutionId, this.added_tags[index].id, "TagEditor")
          .then(
            success => {
              this.added_tags.splice(index, 1);
              this.temas = [];
            }
          )
      },
      returnValue(item, key) {
        if (item && item[key]) {
          return item[key];
        } else {
          return item;
        }
      },
      findTag(query) {
        if(query.length > 2) {
          findTags(query)
            .then(
              success => {
                let tags = []
                success.data.items.map(item => {
                  tags.push(item);
                })
                this.temas = tags;
              }
            )
        }
      },
      updateAddedTags(value) {
        if (value[0]) {
          saveTag(this.solutionId, { tag: value[0].text }, "TagEditor")
            .then(
              success => {
                this.added_tags.push(value[0]);
                this.temas = [];
              }
            )
        }
      }
    }
  }
</script>

<style lang="scss">
  .tags-editor {
    .added-tags-list {
      margin-bottom: 20px;
      .tag-pill {
        background: #339933;
        color: #fff;
        display: inline-block;
        line-height: 1em;
        padding: 4px 5px 4px 6px;
        border-radius: 10px;
        margin-right: 5px;
        .btn-remove {
          padding: 0;
          border: none;
          background: transparent;
          i {
            &:before {
              margin: 0;
            }
          }
        }
      }
    }
  }
</style>
